/*    ********************************
      *      CONTR & BASIC           *
      *   UA6ANN  Alexander Kostyuk  *
      *   RV3BJ   Evgeny Fadeev      *
      ********************************
*/
/************************************************************************************
 $Workfile:  $
 $Header:    $
 $Log:       $
************************************************************************************/

#ifndef __BASINT_H__
#define __BASINT_H__

#define ARITH_BASE short


#define NUM_LAB 40
#define LAB_LEN 4
#define FOR_NEST 5
#define SUB_NEST 5

#define DELIMITER  1
#define VARIABLE  2
#define NUMBER    3
#define COMMAND   4
#define STRING	  5
#define QUOTE	  6

#define PRINT 1
#define INPUT 2
#define IF    3
#define THEN  4
#define FOR   5
#define NEXT  6
#define TO    7
#define GOTO  8
#define EOL   9
#define FINISHED  11
#define GOSUB 12
#define RETURN 15
#define END 16
#define ADC 17
#define DAC 18 
#define SETBIT 19
#define CLRBIT 20
#define TSTBIT 21
#define DELAY  22 
#define STOP  23
#define NORM  24
#define REM   25

#define true 1
#define false 0

#ifdef __BORLANDC__
#define __flash
#endif

typedef struct  { /* keyword lookup table */
  char __flash *command;
  char tok;
} commands_tbl;

typedef struct {
  char name[LAB_LEN];
  char __flash *p;  /* points to place to go in source file*/
} LABEL;

typedef struct {
  int var; /* counter variable */
  ARITH_BASE target;  /* target value */
  char __flash *loc;
} FOR_STACK ;

//typedef struct {
extern char __flash *bas_prog;  /* holds expression to be analyzed */
extern ARITH_BASE bas_variables[26];
extern char bas_token[64];
extern char bas_token_type;
extern char bas_tok;
extern LABEL bas_label_table[NUM_LAB];
extern int bas_ftos;  /* index to top of FOR stack */
extern int bas_gtos;  /* index to top of GOSUB stack */
extern FOR_STACK bas_fstack[FOR_NEST]; /* stack for FOR/NEXT loop */
extern char __flash *bas_gstack[SUB_NEST];	/* stack for gosub */
//} INT_WRK;

//extern INT_WRK *int_wrk;
//extern INT_WRK interpreter_work_area;

void print(void);
void scan_labels(void);
void find_eol(void);
void exec_goto(void);
void exec_if(void);
void exec_for(void);
void next(void);
void fpush(FOR_STACK i);
void input_(void);
void gosub(void);
void greturn(void);
void gpush(char __flash *s);
void label_init(void);
void serror(int error);
void get_exp(ARITH_BASE *result);
void putback(void);
void level2(ARITH_BASE *result);
void level3(ARITH_BASE *result);
void level4(ARITH_BASE *result);
void level5(ARITH_BASE *result);
void level6(ARITH_BASE *result);
void primitive(ARITH_BASE *result);
void unary(char o, ARITH_BASE *r);
void arith(char o, ARITH_BASE *r, ARITH_BASE *h);
int get_token(void);
void assignment(void);
int get_next_label(char *s);
char __flash *find_label(char *s);
int iswhite(char c);
int isdelim(char c);
char look_up(char *s);
int find_var(char *s);
FOR_STACK fpop(void);
char __flash *gpop(void);
void get_param(ARITH_BASE *result);
char get_var(char opt);
int get_line_number(char __flash  *ptr);


#endif
