/*    ********************************
      *      CONTR & BASIC           *
      *   UA6ANN  Alexander Kostyuk  *
      *   RV3BJ   Evgeny Fadeev      *
      ********************************
*/
/************************************************************************************
 $Workfile:  $
 $Header:    $
 $Log:       $
************************************************************************************/
#include "includes.h"
#pragma segment="BASIC_PROGRAM"
#pragma segment="FL_UTIL"

char sound_flag = 1;
volatile short del_timer = (short)bas_program;
volatile char delay_flag = 0;
void interpreter_main(void);
int  putchar(int c);
unsigned char keep_alive_timer = 0;
unsigned char flash_flag = 0;

#define TDELAY 5 /* 500 uS */
#define T0_VALUE  (256 - (FOSC * TDELAY)/640000)



int get_start_basic_area(void)
{
int delta;
int start_raw = (int)__segment_begin("BASIC_PROGRAM");
  if((delta = start_raw % BYTES_FLASH_PSIZE) != 0)
       start_raw += (BYTES_FLASH_PSIZE - delta);
   return start_raw;

}

static char ff;
#pragma vector = TIMER0_OVF_vect
__interrupt void TIMER0_ovf(void)
{
 TCNT0 = T0_VALUE;
 if(sound_flag)
   PORTD ^= (1 << PD3);
ff++;
if(ff & 0x01)
{
if(keep_alive_timer)
  {
   keep_alive_timer--;
   if(keep_alive_timer == 0)
        LED5_OFF();
  }
   if(del_timer)
   {
      del_timer--;
      if(del_timer == 0)
         delay_flag = 1;
   }
}
}


int wait_symbol(int del)
{
int ch;

  for(del_timer = del; del_timer != 0; )
  {
   ch = get_char();
         if(ch != -1)
             return ch;
  }
return -1;
}

short get_adc(void)
{
short tmp,adc;
tmp = ADCL;
adc = ADCH;
adc = (adc << 8) + tmp;

return adc;
}



void load_program(void)
{
unsigned char *buf;
char i;
unsigned long blk;
int ch;
int del = 32767;
putstr("\r\nReflash\r\n");

blk = START_BASIC_PROGRAM / BYTES_FLASH_PSIZE;
  buf = START_BUF;
  i = 0;
  while(1)
  {

    if((ch = wait_symbol(del)) != -1)
    {
      del = 500;
      buf = flash_byte(buf,&blk,ch);
      i++;
    }
      else
    {
       buf = flash_byte(buf,&blk,0x0D);
       buf = flash_byte(buf,&blk,0x0A);
       buf = flash_byte(buf,&blk,0x00);
       if(buf - START_BUF)
           FlashPage(blk,START_BUF,(unsigned char*)buf - START_BUF);

       putstr("\r\nOK");
       break;
      }

  }
}


void main(void)
{
int ch = 0;
//----------------------------------
// TIMER0 init
//----------------------------------
 _CLI();
  TCNT0 = T0_VALUE;      // 1 mS
  TIMSK = TIMSK | 1;
  TCCR0 = 0x03;
  UBRRH = 0;
   DDRB |= (1 << PB1);
   DDRD |= (1 << PD3);
   TCNT1H = 0;
   TCNT1L = 0;

   OCR1AH  = (0);
   OCR1AL  = (0);

   TCCR1A = (1 << COM1A1) + (1 << WGM10) + (1 << WGM11);
   TCCR1B = (1 << CS10) + (0 << WGM12) + (0 << WGM13);

   TIFR |= (1 << OCF1A);
   TIFR |= (1 << TOIE1);

    ADMUX = 0x00;
    ADCSR  = (1 << ADEN) + (1 << ADFR) + 5;
    ADCSR  |= (1 << ADSC);

  LED5_OFF();
  LED5_INIT();
  LED1_4_INIT();
  PROTECT_PIN_INIT();
  CTS_INIT();
  CTS_HIGH();

DDRD &= ~(0xF0);
PORTD |= (0xF0);

//              UCSRB = 0;              // disable UART
              UBRRL = br57600;        // set Baud rate
              UCSRB = 0x98;           // enable uart receive + transmit + rxc interrupt

_SEI();

putstr("\r\nTiny-Basic Ver. ");putstr(__FW_VERSION__);
putstr("\r\nProgram area ");putstr(int_to_str(SIZE_OF_BASIC_PROGRAM - 4));putstr(" bytes\r\n\r\n");

delay_ms(75);
sound_flag = 0;

if(PROTECT_PIN())
ch = wait_symbol(1000);

if(ch == 0x20)
  {
   flash_flag = 0x55;
    load_program();
  }
else if(ch == 0x0D)
  putstr_P((__flash char*)( START_BASIC_PROGRAM));
else
   interpreter_main();
}


