/*    ********************************
      *      CONTR & BASIC           *
      *   UA6ANN  Alexander Kostyuk  *
      *   RV3BJ   Evgeny Fadeev      *
      ********************************
*/
/************************************************************************************
 $Workfile:  $
 $Header:    $
 $Log:       $
************************************************************************************/

#include "includes.h"


// param page The page number to program, 0..479.
// param data Pointer to the new page contents.
// param len  Number of bytes to program. If this is
//            less than 256, then the remaining bytes
//            will be filled with 0xFF.
//

typedef unsigned char uchar;
typedef unsigned int uint;

void fill_temp_buffer(uint, uint);
void write_page(uint)  ;
void erase_page(uint)  ;
void write_lock_bits(uchar);
void unlock_mem(void);




unsigned char read_program_memory(unsigned short address);
void erase_page(uint address)  @ "FL_UTIL"
  {
  while (SPMCR & 0x01 ){};
  __AddrToZByteToSPMCR_SPM((void __flash*)(address), 0x03);
  unlock_mem();
  }

void fill_temp_buffer(uint address, uint data)  @ "FL_UTIL"
  {
  while (SPMCR & 0x01 ){};
  _SPM_FILLTEMP(address,data);
  }

void write_page(uint address)  @ "FL_UTIL"
  {
  while (SPMCR & 0x01 ){};
  _SPM_PAGEWRITE(address);
  unlock_mem();
  }

unsigned char read_program_memory(unsigned short address)  @ "FL_UTIL"
  {
  return __AddrToZByteToSPMCR_LPM((void __flash*)address, 0x00);
  }

void write_lock_bits(uchar data)  @ "FL_UTIL"
  {
  while (SPMCR & 0x01 ){};
  __DataToR0ByteToSPMCR_SPM(data,0x09);
  unlock_mem();
  }

void unlock_mem(void)  @ "FL_UTIL"
  {
  while (SPMCR & 0x01) {} ;
  __DataToR0ByteToSPMCR_SPM(0,0x11);
  }



void FlashPage(unsigned long page, void *data, unsigned short len)  @ "FL_UTIL"
{
    unsigned short i;
    unsigned short *wp = data;
CTS_LOW();
 if(page < 124)
 {
      putchar('W');

    page <<= 6; // for 64 bytes per page
_CLI();
    erase_page(page);
 _SEI();
    for (i = 0; i < len; i += 2, wp++)
    fill_temp_buffer(i,*wp);

    for (; i < BYTES_FLASH_PSIZE; i += 2)
    fill_temp_buffer(i,0xffff);
_CLI();
   write_page(page);
_SEI();
}
CTS_HIGH();
}
extern unsigned char flash_flag;
unsigned char *flash_byte(unsigned char *buf,unsigned long *blk, char symbol)  @ "FL_UTIL"
{

    *buf++ = symbol;
   if(buf == (START_BUF + BYTES_FLASH_PSIZE))
   {
      if(flash_flag == 0x55)
      FlashPage(*blk,START_BUF,(unsigned char*)buf - START_BUF);
      *blk += 1;
    buf = START_BUF;
   }

return buf;


}
